VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsProgBar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Private Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

Private Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long

Private Declare Function Rectangle Lib "gdi32" (ByVal hdc As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long

Private Declare Function SaveDC Lib "gdi32" (ByVal hdc As Long) As Long

Private Declare Function RestoreDC Lib "gdi32" (ByVal hdc As Long, ByVal nSavedDC As Long) As Long

Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long

Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long

Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long

Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long

Private Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hdc As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long

Private Declare Function SetBkMode Lib "gdi32" (ByVal hdc As Long, ByVal nBkMode As Long) As Long

Private Declare Function SetTextColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long

Private Declare Function GetBkColor Lib "gdi32" (ByVal hdc As Long) As Long

Private Const DT_CENTER = &H1

Private bColor_loc As Long
Private fColor_loc As Long
Private tColor_loc As Long

Private prgMin     As Long
Private prgMax     As Long
Private prgValue   As Long

Private hwnd       As Long
Private hdc        As Long
Private iDc        As Long
Private hBrush_1   As Long
Private hBrush_2   As Long
Private MainRect   As RECT
Private txtRect    As RECT

Private flgPrep    As Boolean
Private flgCannot  As Boolean

Private X1         As Long
Private Y1         As Long
Private X2         As Long
Private Y2         As Long
Private Pbw        As Long
Private Pbh        As Long

Private dxCurr     As Long
Private dxLast     As Long

Public Property Let Min(vMin As Long)

       prgMin = vMin

End Property

Public Property Get Min() As Long

       Min = prgMin

End Property


Public Property Let Max(vMax As Long)

       prgMax = vMax

End Property

Public Property Get Max() As Long

       Max = prgMax

End Property

Public Property Let Value(vVal As Long)

       prgValue = vVal

End Property

Public Property Get Value() As Long

       Value = prgValue

End Property

Public Property Get bColor() As Long

       bColor = bColor_loc

End Property

Public Property Let bColor(ByVal vNewValue As Long)

       bColor_loc = vNewValue

End Property

Public Property Get fColor() As Long

       fColor = fColor_loc

End Property

Public Property Let fColor(ByVal vNewValue As Long)

       fColor_loc = vNewValue

End Property

Public Property Get tColor() As Long

       tColor = tColor_loc

End Property

Public Property Let tColor(ByVal vNewValue As Long)

       tColor_loc = vNewValue

End Property

Private Sub Class_Initialize()

        prgMax = 100
        prgMin = 0
        prgValue = 0

        fColor_loc = RGB(0, 0, 128)
        bColor_loc = RGB(130, 130, 180)
        tColor_loc = RGB(255, 255, 0)
        
        dxCurr = 0
        dxLast = 0
        
        flgPrep = False
        flgCannot = False

End Sub

Private Sub Prepare(StatBar As Object, NPan As Integer)
        
        scMode% = StatBar.Parent.ScaleMode
        
        Select Case scMode%
        
               Case 1  '::: Twip = 1/1440 
               
                    ppx# = Screen.TwipsPerPixelX
                    ppy# = Screen.TwipsPerPixelY
               
               Case 2  '::: Point = 1/72 
               
                    ppx# = Screen.TwipsPerPixelX / 20
                    ppy# = Screen.TwipsPerPixelY / 20
               
               Case 3  '::: Pixel
               
                    ppx# = 1
                    ppy# = 1
               
               Case 4  ':::
               
                    ppx# = Screen.TwipsPerPixelX / 120
                    ppy# = Screen.TwipsPerPixelY / 240
               
               Case 5  '::: 
               
                    ppx# = Screen.TwipsPerPixelX / 1440
                    ppy# = Screen.TwipsPerPixelY / 1440
               
               Case 6  '::: 
               
                    ppx# = (Screen.TwipsPerPixelX / 1440) * 25.4
                    ppy# = (Screen.TwipsPerPixelY / 1440) * 25.4
               
               Case 7  '::: 
               
                    ppx# = (Screen.TwipsPerPixelX / 1440) * 2.54
                    ppy# = (Screen.TwipsPerPixelY / 1440) * 2.54
               
               Case Else
                    
                    StatBar.Panels(NPan).Text = "  "
                    
                    flgCannot = True
                    Exit Sub
               
        End Select
        
        ':::  handle  -
        
        hwnd = StatBar.hwnd

        '::: 

        'l& = GetWindowRect(hwnd, MainRect)

        ':::    ,   

        hdc = GetDC(hwnd)

        ':::  ...

        iDc = SaveDC(hdc)

        ':::     

        hBrush_1 = CreateSolidBrush(fColor)

        ':::     

        hBrush_2 = CreateSolidBrush(bColor)

        ':::    -2 

        Pbw = (StatBar.Panels(NPan).Width) / ppx# - 2
        
        ':::    -2 
        
        Pbh = (StatBar.Height) / ppy# - 2
        
        ':::  X-   
        
        X1 = -(StatBar.Left / ppx#) + (StatBar.Panels(NPan).Left) / ppx# + 1
        
        ':::  Y-   
        
        Y1 = (StatBar.Top) / ppy# + 1
         
        ':::  X-   
         
        X2 = X1 + Pbw
        
        ':::  X-   
        
        Y2 = Y1 + Pbh

        With txtRect
             .Top = 1
             .Left = X1
             .Right = X1 + Pbw
             .Bottom = 1 + Pbh
        End With

        a& = SetBkMode(hdc, 1)

        P& = SetTextColor(hdc, tColor)

        ttl$ = "100%"
        ltxt& = 1

        Ht& = DrawText(hdc, ttl$, ltxt&, txtRect, &H400)

        With txtRect
             .Top = 1 + (Pbh - Ht&) / 2
             .Left = X1
             .Right = X1 + Pbw
             .Bottom = txtRect.Top + Ht&
        End With

        flgPrep = True
        flgOK = True

End Sub

Public Sub ShowProgress(StatBar As Object, NPan As Integer)

       If flgCannot Then Exit Sub

       If (Not flgPrep) Then Prepare StatBar, NPan

       If flgPrep Then

          SS# = prgValue
          ZZ# = Abs(prgMax - prgMin)

          Fract# = (SS# / ZZ#)
        
          dxCurr = Pbw * Fract#
        
          If dxCurr <> dxLast Then
       
             ttl$ = Format$(Fract#, "##0%")
        
             SelectObject hdc, hBrush_1
        
             Rectangle hdc, X1, 2, (X1 + dxCurr), Pbh

             SelectObject hdc, hBrush_2

             Rectangle hdc, (X1 + dxCurr - 1), 2, (X1 + Pbw), Pbh

             ltxt& = Len(ttl$)

             a& = DrawText(hdc, ttl$, ltxt&, txtRect, DT_CENTER)
          
             dxLast = dxCurr
          
             DoEvents
             
          End If
          
       End If

End Sub

Private Sub Class_Terminate()

        If flgPrep Then

           q& = DeleteObject(hBrush_1)
           
           q& = DeleteObject(hBrush_2)

           i& = RestoreDC(hdc, iDc)

        End If
        
End Sub


